Changes between Version 1 and Version 2 of TracPlugins


Ignore:
Timestamp:
Jun 14, 2010 11:11:20 PM (4 years ago)
Author:
trac
Comment:

--

Legend:

Unmodified
Added
Removed
Modified
  • TracPlugins

    v1 v2  
    33 
    44Since version 0.9, Trac supports [trac:PluginList plugins] that extend the built-in functionality. The plugin functionality is based on the [trac:TracDev/ComponentArchitecture component architecture]. 
     5 
     6Plugins can be either installed globally, in a shared plugins directory  (see [TracIni#GlobalConfiguration Global Configuration]) or locally for specific TracEnvironment, in its `plugins` directory. 
     7Except for the later case, the components defined in a plugin should be explicitly enabled in the [[TracIni#components-section| [components] ]] section of the trac.ini file. 
    58 
    69== Requirements == 
     
    1518If the `ez_setup.py` script fails to install the setuptools release, you can download it from [http://www.python.org/pypi/setuptools PyPI] and install it manually. 
    1619 
    17 Plugins can also consist of a single `.py` file dropped into either the environment or global `plugins` directory ''(since [milestone:0.10])''. See TracIni#GlobalConfiguration . 
     20Plugins can also consist of a single `.py` file dropped into either the environment or the shared plugins directory. 
    1821 
    1922== Installing a Trac Plugin == 
     
    3235Then you will have a *.egg file. Examine the output of running python to find where this was created. 
    3336 
    34 Once you have the plugin archive, you need to copy it into the `plugins` directory of the [wiki:TracEnvironment project environment]. Also, make sure that the web server has sufficient permissions to read the plugin egg. 
     37Once you have the plugin archive, you need to copy it into the `plugins` directory of the [wiki:TracEnvironment project environment]. Also, make sure that the web server has sufficient permissions to read the plugin egg. Then, restart the web server (this requirement was not previously mentioned in this document, but in my tests it began working only after I did so). 
    3538 
    3639To uninstall a plugin installed this way, remove the egg from `plugins` directory and restart web server. 
     
    3841Note that the Python version that the egg is built with must 
    3942match the Python version with which Trac is run.  If for 
    40 instance you are running Trac under Python 2.3, but have 
    41 upgraded your standalone Python to 2.4, the eggs won't be 
     43instance you are running Trac under Python 2.5, but have 
     44upgraded your standalone Python to 2.6, the eggs won't be 
    4245recognized. 
    4346 
     
    5356}}} 
    5457 
    55 If `easy_install` is not on your system see the Requirements section above to install it.  Windows users will need to add the `Scripts` directory of their Python installation (for example, `C:\Python23\Scripts`) to their `PATH` environment variable (see [http://peak.telecommunity.com/DevCenter/EasyInstall#windows-notes easy_install Windows notes] for more information). 
     58If `easy_install` is not on your system see the Requirements section above to install it.  Windows users will need to add the `Scripts` directory of their Python installation (for example, `C:\Python24\Scripts`) to their `PATH` environment variable (see [http://peak.telecommunity.com/DevCenter/EasyInstall#windows-notes easy_install Windows notes] for more information). 
    5659 
    5760If Trac reports permission errors after installing a zipped egg and you would rather not bother providing a egg cache directory writable by the web server, you can get around it by simply unzipping the egg. Just pass `--always-unzip` to `easy_install`: 
     
    6164You should end up with a directory having the same name as the zipped egg (complete with `.egg` extension) and containing its uncompressed contents. 
    6265 
    63 Trac also searches for globally installed plugins ''(since 0.10)'', see TracIni#GlobalConfiguration. 
     66Trac also searches for plugins installed in the shared plugins directory ''(since 0.10)'', see TracIni#GlobalConfiguration. This is a convenient way to share the installation of plugins across several but not all environments. 
    6467 
    6568==== From source ==== 
     
    6770`easy_install` makes installing from source a snap. Just give it the URL to either a Subversion repository or a tarball/zip of the source: 
    6871{{{ 
    69 easy_install http://svn.edgewall.com/repos/trac/sandbox/spam-filter 
     72easy_install http://svn.edgewall.com/repos/trac/plugins/0.11/spam-filter 
    7073}}} 
    7174 
    7275==== Enabling the plugin ==== 
    73 Unlike plugins installed per-environment, you'll have to explicitly enable globally installed plugins via [wiki:TracIni trac.ini]. This also applies to plugins installed in the path specified in the `[inherit] plugins_dir` configuration option. This is done in the `[components]` section of the configuration file, for example: 
     76Unlike plugins installed per-environment, you'll have to explicitly enable globally installed plugins via [wiki:TracIni trac.ini]. This also applies to plugins installed in shared plugins directory, i.e. the path specified in the `[inherit] plugins_dir` configuration option.  
     77 
     78This is done in the `[components]` section of the configuration file, for example: 
    7479{{{ 
    7580[components] 
     
    151156=== Did you get the correct version of the Python egg? === 
    152157 
    153 Python eggs have the Python version encoded in their filename. For example, `MyPlugin-1.0-py2.4.egg` is an egg for Python 2.4, and will '''not''' be loaded if you're running a different Python version (such as 2.3 or 2.5). 
     158Python eggs have the Python version encoded in their filename. For example, `MyPlugin-1.0-py2.5.egg` is an egg for Python 2.5, and will '''not''' be loaded if you're running a different Python version (such as 2.4 or 2.6). 
    154159 
    155160Also, verify that the egg file you downloaded is indeed a ZIP archive. If you downloaded it from a Trac site, chances are you downloaded the HTML preview page instead.